part of xwidgetbase;

class XItem extends StatelessWidget {
  final Function? onTap;
  final String? label;
  final List<Widget>? children;
  final Widget? labelWidget;
  final bool labelOnTop;
  final bool visibleBottomBorderOfCard;

  final BoxConstraints? constraints;
  final CrossAxisAlignment? childrensCrossAxisAlignment;
  final MainAxisAlignment? mainAxisAlignmentlabel;
  final CrossAxisAlignment? crossAxisAlignmentLabelOnTop;
  final TextAlign labelTextAlign;
  final AlignmentGeometry? alignmentLabelOnLeft;
  final AlignmentGeometry? alignmentLabelOnTop;

  final Decoration? decorationXItem;
  final TextStyle? styleLabel;
  final double labelWidth;
  final double? labelHeight;
  final double? widthBorderTitleContainer;
  final Color? backGroundColorTitleContainer;
  final Color? colorCard;
  final Color? colorLabel;
  XItem({
    Key? key,
    this.onTap,
    this.alignmentLabelOnTop = Alignment.center,
    this.labelWidget,
    this.crossAxisAlignmentLabelOnTop,
    this.colorCard,
    this.styleLabel,
    this.alignmentLabelOnLeft,
    this.mainAxisAlignmentlabel,
    this.visibleBottomBorderOfCard = false,
    this.colorLabel,
    this.decorationXItem,
    this.label = "",
    this.labelWidth = 150,
    this.labelHeight,
    this.children,
    this.childrensCrossAxisAlignment,
    this.labelOnTop = false,
    this.labelTextAlign = TextAlign.center,
    this.backGroundColorTitleContainer,
    this.widthBorderTitleContainer,
    double? width,
    double? height,
    BoxConstraints? constraints,
  })  : constraints = (width != null || height != null) ? constraints?.tighten(width: width, height: height) ?? BoxConstraints.tightFor(width: width, height: height) : constraints,
        super(key: key);
  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: onTap as void Function()?,
        child: ConstrainedBox(
          constraints: constraints ?? BoxConstraints(),
          child: Container(
            child: Card(
              color: colorCard ?? Colors.transparent,
              child: Container(
                  decoration: visibleBottomBorderOfCard == true ? BoxDecoration(border: Border(bottom: BorderSide(width: 6, color: Colors.blue.withOpacity(0.5)))) : decorationXItem,
                  child: Column(
                    // crossAxisAlignment: crossAxisAlignmentLabelOnTop ?? CrossAxisAlignment.center,
                    children: [
                      labelOnTop || label != null
                          ? Container(
                              alignment: alignmentLabelOnTop ?? Alignment.center,
                              width: labelWidth,
                              height: labelHeight,
                              color: backGroundColorTitleContainer != null ? null : colorLabel ?? Colors.transparent,
                              margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                              decoration: backGroundColorTitleContainer != null
                                  ? BoxDecoration(
                                      color: backGroundColorTitleContainer ?? Colors.transparent,
                                      border: Border(
                                        top: BorderSide(color: colorLabel ?? Colors.transparent, width: widthBorderTitleContainer ?? 2),
                                        left: BorderSide(color: colorLabel ?? Colors.transparent, width: widthBorderTitleContainer ?? 2),
                                        right: BorderSide(color: colorLabel ?? Colors.transparent, width: widthBorderTitleContainer ?? 2),
                                        bottom: BorderSide(color: colorLabel ?? Colors.transparent, width: widthBorderTitleContainer ?? 2),
                                      ))
                                  : null,
                              child: label!.isNotEmpty
                                  ? Container(
                                      child: Text(
                                        label!,
                                        textAlign: labelTextAlign,
                                        style: styleLabel ?? XStyles.xStyTextForLabel(),
                                      ),
                                    )
                                  : Container(),
                            )
                          : Container(),
                      Row(children: [
                        labelOnTop.not() || label != null
                            ? Container(
                                alignment: alignmentLabelOnLeft ?? Alignment.center,
                                width: labelWidth,
                                height: labelHeight,
                                padding: EdgeInsets.symmetric(vertical: 2),
                                color: colorLabel ?? Colors.transparent,
                                margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                                child: label!.isNotEmpty
                                    ? labelWidget ??
                                        Container(
                                          child: Text(
                                            label!,
                                            textAlign: labelTextAlign,
                                            style: styleLabel ?? XStyles.xStyTextForLabel(),
                                          ),
                                        )
                                    : Container(),
                              )
                            : Container(),
                        Expanded(
                          child: Row(children: [
                            Expanded(
                              child: Wrap(crossAxisAlignment: WrapCrossAlignment.center, spacing: 5, runSpacing: 5, children: children!),
                            ),
                          ]),
                        ),
                      ]),
                    ],
                  )),
            ),
          ),
        ));
  }
}
